{
          UnAce.dll dynamic wrapper component v0.2.X
                     by Rogier Timmermans
-------------------------------------------------------------
              Contact info : MagicRT@Hotmail.com
              WebSite : Http://rtimmermans.webjump.com
-------------------------------------------------------------
Based on "delphi-example" from Christian Ghisler which is
included with the Dll and on my own RTdUnRar Dll wrapper Component
(it's practically a mirror image of it).

I've done a number of other wrappers, for unrar.dll, Bass.Dll and Bassmod.Dll, all employing dynamic dll loading and all extremely easy to use...

Note :
------
- For more info on Unace.dll try the WinAce homepage : http://www.winace.com

Version Info :

version : 0.2.X

changes since v0.1 :
------------------------------

v0.1a)
- New function, retreives a string based on error code...not much, but it's an improvement, right ?

v0.1b.X)
- Added List & Test functions/methods whatever you prefer to call'em.
- Two new Events for each of these two as well; the "Being" are triggered just before, the other
  is triggered when action has been completed on the current file
- Added new OnChangeVolume Event; you only need to respond if code = ACEVOL_REQUEST,
  you should then bother the user to enter the path to the next volume,
  if code="OPENED", dll is notifying you the the next archive was succesfully opened...
- The X is in the version because i haven't tested anything, it compiles and it looks good, no guarantees !
  As long as no one tries it out and gives me feedback, the X is staying...

v0.1b.X2)
- Feedback came in ! The Following Fixes were applied :
- Listing was reported to work, so no changes.
- Testing was reported to fail, I dunno, it works here, but I've streamlined the code and removed some excess lines as well...
- Extracting was also reported to fail...strange, it worked in the old version and nothing changed...
  oh well, code has been streamlined a bit too...
- Added a little demo app...tests, lists & unpacks...nothing fancy though...just
  a quick 50 minutes job (including the component fixing and drinking two mugs of coffee...).

v0.1b.X3)
- Extract & Test problem was not my fault; it worked, the tester used the New WinAce to pack the files, no wonder it failed...all solved !
- Support for Password protected Arcs...bit 14 in header indicates presence -> 2^14 = 16384
- New event for PW requests...enjoy !

v0.1c.X)
- Single File Processing Support...once again untested (am I lazy or what ? ;-)!)
  Hey, the code comes straight from My Rar wrapper component...

v0.2.X)
- Now virtually equal to my RTdUnRar Wrapper;
  - Single File Processing bug has been solved (my mistake, sorry !)
    Yeah, the same bug from RTdUnRar crept in here as well...but both components are fixed,
    and i've tested it, so everything is now ok !
  - New ValidateArchive Function allows you to check for a Ace Archive...works also...
    equals 0 when file is 'valid'

}

unit RTdunAce;

interface
uses messages, windows, sysutils, dialogs, classes;

const

  UnPack_UnAceDllNotLoaded =-101;
  UnPack_OK =100;
  UnPack_Stopped=110;
  UnPack_Opened=0;
  UnPack_Done =0;
  Unpack_ReadErr =101;

  ACEERR_MEM=      1;
  ACEERR_FILES=    2;
  ACEERR_FOUND=    3;
  ACEERR_FULL=     4;
  ACEERR_OPEN=     5;
  ACEERR_READ=     6;
  ACEERR_WRITE=    7;
  ACEERR_CLINE=    8;
  ACEERR_CRC=      9;
  ACEERR_OTHER=   10;
  ACEERR_EXISTS=  11;
  ACEERR_END=      128;
  ACEERR_HANDLE=   129;
  ACEERR_CONSTANT= 130;
  ACEERR_NOPASSW=  131;
  ACEERR_METHOD=   132;
  ACEERR_USER=   255;

  ACEOPEN_LIST=    0;
  ACEOPEN_EXTRACT= 1;

  ACECMD_SKIP=     0;
  ACECMD_TEST=     1;
  ACECMD_EXTRACT=  2;

  ACEVOL_REQUEST=  0;
  ACEVOL_OPENED=   1;


  ACESEL_YES=      0;
  ACESEL_ALWAYS=   1;
  ACESEL_NO=       2;
  ACESEL_CANCEL=   3;

  ACECMT_OK=       0;
  ACECMT_SMALLBUF= 1;
  ACECMT_NONE=   255;

  ACE_FILEFLAG_PASSWORD=16384;

type
  pbyte=^byte;
  TChangeVolProc=function(ArcName:pchar;Mode:longint):longint;
  TProcessDataProc=function(Addr:pbyte;Size:longint):longint;

type
  TACEHeaderData=packed record
    ArcName:array [0..259] of char;
    FileName:array [0..259] of char;
    Flags,
    PackSize,
    UnpSize,
    FileCRC,
    FileTime,
    Method,
    QUAL,
    FileAttr:longint;
    CmtBuf:pchar;
    CmtBufSize,
    CmtSize,
    CmtState:longint;
  end;

  tACEOpenArchiveData=packed record
    ArcName:pchar;
    OpenMode,
    OpenResult,
    Flags,
    Host:longint;
    AV:array[0..50] of char;
    CmtBuf:pchar;
    CmtBufSize,
    CmtSize,
    CmtState:longint;
    ChangeVolProc:TChangeVolProc;
    ProcessDataProc:TProcessDataProc;
  end;

type
  TACEOpenArchive=function(var ArchiveData:tACEOpenArchiveData):thandle; stdcall;
  TACECloseArchive=function(hArcData:thandle):longint; stdcall;
  TACEReadHeader=function(hArcData:thandle;var HeaderData:TACEHeaderData):longint; stdcall;
  TACEProcessFile=function(hArcData:thandle;Operation:longint;DestPath:pchar):longint; stdcall;
  TACESetPassword=function(hArcData:thandle;Password:pchar):longint; stdcall;

var
  ACEOpenArchive:TACEOpenArchive;
  ACECloseArchive:TACECloseArchive;
  ACEReadHeader:TACEReadHeader;
  ACEProcessFile:TACEProcessFile;
  ACESetPassword:TACESetPassword;


type TErrorProc          = procedure (Sender: TObject; Error : Integer) of object;
     TFileBeingExtracted = procedure (Sender: TObject; eFile : TAceHeaderData) of object;
     TFileBeingTested    = procedure (Sender: TObject; eFile : TAceHeaderData) of object; 
     TFileBeingListed    = procedure (Sender: TObject; eFile : TAceHeaderData) of object;
     TFileExtracted      = procedure (Sender: TObject; eFile : TAceHeaderData; Result : Boolean) of object;
     TFileListed         = procedure (Sender: TObject; eFile : TAceHeaderData; Result : Boolean) of object; 
     TFileTested         = procedure (Sender: TObject; eFile : TAceHeaderData; Result : Boolean) of object;
     TProcessDataProcN   = function (Sender: TObject; Addr : Pbyte; BlockSize, Position : Integer) : Integer of object;
     TChangeVolProcN     = function (Sender: TObject; ArcName : PChar; Mode : Integer) : Integer of object;

     TReqPassword        = procedure (Sender: TObject; eFile : TAceHeaderData; var Password : String) of object;

     

Type TdAce=class(TComponent)
   private
     FArchive_file              : string;
     FTarget_dir                : string;
     FUnAceDllPath              : string;

     FError                     : TErrorProc;
     FFileExtracted             : TFileExtracted;
     FFileBeingExtracted        : TFileBeingExtracted;
     FFileTested                : TFileTested;
     FFileBeingTested           : TFileBeingTested;
     FFileListed                : TFileListed;
     FFileBeingListed           : TFileBeingListed;
     FOnProgress                : TProcessDataProcN;
     FOnChangeVolume            : TChangeVolProcN;
     FReqPassword               : TReqPassword; // your request PW procedure...

     FStop                      : Boolean;

     FActualPos                 : Integer;


     FFilesToProcess            : TStringList;
     procedure SetFilesToProcess(Value : TStringList);
   

   protected
   public
    constructor Create(AOwner : TComponent); override;
    destructor Free;
    Function ExtractArchive:integer;
    Function TestArchive:integer;
    Function ListArchive:integer;
    Function ValidateArchive:integer;
    Function GetAceErrorString(Error : Integer) : String;
   published
    property Archivefilename : string
      read FArchive_file write FArchive_file;
    property TargetDirectory : string
      read FTarget_Dir write FTarget_Dir;
    property Path2UnAceDll : string
      read FUnAceDllPath write FUnAceDllPath;

    property Stop : Boolean
      read FStop write FStop default False;

    property OnError : TErrorProc
      read FError write FError;
    property OnExtracting : TFileBeingExtracted
      read FFileBeingExtracted write FFileBeingExtracted;
    property OnExtract : TFileExtracted
      read FFileExtracted write FFileExtracted;

    property OnTesting : TFileBeingTested
      read FFileBeingTested write FFileBeingTested;
    property OnTest : TFileTested
      read FFileTested write FFileTested;

    property OnListing : TFileBeingListed
      read FFileBeingListed write FFileBeingListed;
    property OnList : TFileListed
      read FFileListed write FFileListed;

    property OnProcessData : TProcessDataProcN
      read FOnProgress write FOnProgress;

    property OnVolumeChange : TChangeVolProcN
      read FOnChangeVolume write FOnChangeVolume;

    property OnReqPassword : TReqPassword
      read FReqPassword write FReqPassword;

   property FilesToProcess : TStringList
      read FFilesToProcess write SetFilesToProcess;

 end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Rogier Timmermans'' Components', [TdACE]);
end;

const AceDllHandle:thandle=0;
const UnAceHandle:thandle=0;

constructor TdAce.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FFilesToProcess:=TStringList.Create;
  FFilesToProcess.Sorted:=True;
 
end;

destructor TdAce.Free;
begin
  FFilesToProcess.Free;
  inherited free;
end;

Procedure UnloadAceDll;
begin
  if RtdunAce.AceDllHandle<>0 then
    FreeLibrary(RtdunAce.AceDllHandle);
  RtdunAce.AceDllHandle:=0;
end;

procedure CloseAcefile;
begin
  if RtdunAce.unAcehandle<>0 then
    AceCloseArchive(RtdunAce.unAcehandle);
  RtdunAce.unAcehandle:=0;
end;

Function LoadAceDLL (const dllpath:string) :boolean;
var DlPath:String;
var pt:pchar;
var oldmode:integer;
begin
  if RtdunAce.AceDllHandle<>0 then result:=true
  else begin
    if (dllpath[length(dllpath)]<>'\') then dlpath:=dllpath+'\'
      else dlpath:=dllpath;
    pt:=pchar(dlpath+'unace.dll');
    oldmode:=SetErrorMode($8001);
    RtdunAce.AceDllHandle:=LoadLibrary(pt);
    SetErrorMode(oldmode);
    if RtdunAce.AceDllHandle<>0 then begin

      @ACEOpenArchive:=GetProcAddress(RtdunAce.AceDllHandle,'ACEOpenArchive');
      @ACECloseArchive:=GetProcAddress(RtdunAce.AceDllHandle,'ACECloseArchive');
      @ACEReadHeader:=GetProcAddress(RtdunAce.AceDllHandle,'ACEReadHeader');
      @ACEProcessFile:=GetProcAddress(RtdunAce.AceDllHandle,'ACEProcessFile');
      @ACESetPassword:=GetProcAddress(RtdunAce.AceDllHandle,'ACESetPassword');
      if (@ACEOpenArchive=nil) or (@ACECloseArchive=nil) or (@ACEReadHeader=nil) or
         (@ACEProcessFile=nil) or (@ACESetPassword=nil) then begin
        FreeLibrary(RtdunAce.AceDllHandle);
        RtdunAce.AceDllHandle:=0;
      end;
    end;
    result:=RtdunAce.AceDllHandle<>0;
  end;
end;

var xself:pointer;

function ProgressProc(Addr:pbyte;Size:longint):longint;
begin
  TdAce(xself).FActualPos:=(TdAce(xSelf).FActualPos+Size);
  TdAce(xself).OnProcessData(xself,Addr,size,TdAce(xself).FActualPos); {fire event}
  Result:=ord(not tdAce(xself).stop); // interupt unpacking immediately, returns 255
end;

function ChangeProc(ArcName:pchar;Mode:longint):longint;
begin
//result:=1; // not implemented yet...
Result:=TdAce(xSelf).OnVolumeChange(xSelf,ArcName,Mode);
end;

Function TdAce.GetAceErrorString(Error : Integer) : String;
{
  ACEERR_MEM=      1;
  ACEERR_FILES=    2;
  ACEERR_FOUND=    3;
  ACEERR_FULL=     4;
  ACEERR_OPEN=     5;
  ACEERR_READ=     6;
  ACEERR_WRITE=    7;
  ACEERR_CLINE=    8;
  ACEERR_CRC=      9;
  ACEERR_OTHER=   10;
  ACEERR_EXISTS=  11;
  ACEERR_END=      128;
  ACEERR_HANDLE=   129;
  ACEERR_CONSTANT= 130;
  ACEERR_NOPASSW=  131;
  ACEERR_METHOD=   132;
  ACEERR_USER=   255;
}
begin
  case Error of
    UnPack_UnAceDllNotLoaded : Result:='Unable to load UnAce.Dll...';
    ACEERR_END ,UnPack_OK : Result:='End of archive, All Done !';
    ACEERR_MEM      : Result:='Not enough memory to initialize data structures';
    ACEERR_CRC      : Result:='CRC error, data damaged';
    ACEERR_OPEN     : Result:='Unable to open file...';
    ACEERR_EXISTS   : Result:='File already exists...';
    ACEERR_USER, UnPack_Stopped : Result:='Decompression Canceled by user !';
    else Result:='Spurious error occured !'+#13#13+'Code :'+inttostr(Error);
  end;
end;


procedure TdAce.SetFilesToProcess(Value : TStringList);
begin
  FFilesToProcess.Assign(Value);
end;


Function TdAce.ExtractArchive:integer;
var ACEOpenArchiveData:tACEOpenArchiveData;
    ACEHeaderData:tACEHeaderData;
    err:integer;
    temp:integer;
    Extractdone:boolean;
    s,password:string;  
Begin
  xSelf:=Self;
  if (not LoadAceDll(Path2UnAceDll)) then
                                      begin
                                        if Assigned(onError) then OnError(Self,UnPack_UnAceDllNotLoaded);
                                        result:=UnPack_UnAceDllNotLoaded;
                                        exit;
                                       end;
  if unAcehandle=0 then begin  {open first!}
    fillchar(AceOpenArchiveData, sizeof(tAceOpenArchiveData),#0); {Clear it, just to make sure !}
    with AceOpenArchiveData do
      begin
        ArcName:=pchar(FArchive_file);        {Set the Archive File}
        OpenMode:=ACEOPEN_EXTRACT;     {Set the open-mode}
        if Assigned(OnProcessData) then ProcessDataProc:=@ProgressProc;
        if Assigned(ChangeVolProc) then ChangeVolProc:=@ChangeProc;
       end;
    unAcehandle:=AceOpenArchive(AceOpenArchiveData); {Now open the Archive and gobble up some memory}

    err:=ACEOpenArchiveData.OpenResult; // get open result...
    case err of {What did opening report ?}
      0: begin err:=unPack_opened; end; {openend}
      // add others here...
     else
      begin err:=unPack_ReadErr;end;
    end;

    if (err<>unpack_opened) then begin {if not opened ok, bail !}
                                 if Assigned(OnError) then OnError(Self,err);
                                 result:=err;
                                 CloseAcefile;
                                 UnloadAceDll;
                                 exit;
                                end;

  fillchar(AceHeaderData,sizeof(TAceHeaderData),#0); // clear it...
  extractdone:=false; // we're not done...
  repeat
     err:=AceReadHeader(unAcehandle,AceHeaderData); // read header...
     if FStop then // did user hit cancel ?
      begin
        CloseAceFile;
        UnloadAceDll;
        result:=UnPack_Stopped;
        FStop:=False;
        Exit;
      end;

    if err<>0 then
       begin
         if Assigned(OnError) then OnError(Self, err);
         if (err=UnPack_Stopped) or (Err=ACEERR_END) then Result:=err; // return correct result...
         if (err<>ACEERR_END) and (err<>UnPack_Stopped) then result:=Unpack_ReadErr; // general read error, -> error in header isn't funny anyway...
         CloseAcefile;
         UnloadAceDll;
         exit;
        end;
      S:=''; for Temp:=0 to SizeOf(AceHeaderData.FileName) do if AceHeaderData.FileName[Temp]=#00 then break else S:=S+AceHeaderData.FileName[Temp]; // get filename from RarHeader
      if Assigned(OnExtracting) then OnExtracting(Self, AceHeaderData);
      FActualPos:=0;
      if TargetDirectory[length(TargetDirectory)]<>'\' then TargetDirectory:=TargetDirectory+'\'; // dir name must end with '\'

    

   if (FFilesToProcess.Count=0) or (FFilesToProcess.Find(S,Temp)) then // extract file or just all
      begin    
        // preliminary password support...begin
        if ((AceHeaderData.Flags and ACE_FILEFLAG_PASSWORD)=ACE_FILEFLAG_PASSWORD) and (Assigned(OnReqPassword)) then
            begin
              OnReqPassword(Self,AceHeaderData,Password);
             if Password<>'' then AceSetPassword(unAcehandle,@Password[1]);
             end;
        // preliminary password support...end
      err:=AceProcessFile(unAcehandle,ACECMD_EXTRACT,pchar(TargetDirectory+AceHeaderData.Filename));
      if Assigned(OnExtract) then OnExtract(Self, AceHeaderData, (err=0) );
      end
     else err:=AceProcessFile(unAcehandle,ACECMD_SKIP,nil);

    if err<>0 then begin
      If Assigned(OnError) then OnError(Self,err);
      extractdone:=true;
    end;
  until extractdone;
  CloseAcefile; // make sure we return the memory we gobbled up; if it's already gone, this won't do a thing...
  UnloadAceDll; // make sure we get rid of the Dll ; if it's already gone, it doesn't do anything
  result:=err;
end;
end;


Function TdAce.TestArchive:integer;
var ACEOpenArchiveData:tACEOpenArchiveData;
    ACEHeaderData:tACEHeaderData;
    err:integer;
    temp:integer;
    Testdone:boolean;
    s,password:string;
Begin
  xSelf:=Self;
  err:=255; // shut up compiler... ;-)
  if (not LoadAceDll(Path2UnAceDll)) then
                                      begin
                                        if Assigned(onError) then OnError(Self,UnPack_UnAceDllNotLoaded);
                                        result:=UnPack_UnAceDllNotLoaded;
                                        exit;
                                       end;
  if unAcehandle=0 then begin  {open first!}
    fillchar(AceOpenArchiveData, sizeof(tAceOpenArchiveData),#0); {Clear it, just to make sure !}
    with AceOpenArchiveData do begin
      ArcName:=pchar(FArchive_file);        {Set the Archive File}
      OpenMode:=ACEOPEN_EXTRACT;     {Set the open-mode}
      ProcessDataProc:=@ProgressProc;
      ChangeVolProc:=@ChangeProc;
    end;
    unAcehandle:=AceOpenArchive(AceOpenArchiveData); {Now open the Archive and gobble up some memory}
    err:=ACEOpenArchiveData.OpenResult;
    if err<>0 then begin {if not opened ok, bail !}
                                if Assigned(OnError) then OnError(Self,err);
                                CloseAcefile;
                                UnloadAceDll;
                                result:=err;
                                exit;
                               end;
  end else
    result:=err;
  fillchar(AceHeaderData,sizeof(TAceHeaderData),#0);
  Testdone:=false;
  repeat
     err:=AceReadHeader(unAcehandle,AceHeaderData);
     if FStop then
      begin
        FStop:=False;
        result:=UnPack_Stopped;
        CloseAceFile;
        UnloadAceDll;
        Exit;
      end;
    if err<>0 then
       begin
         if Assigned(OnError) then OnError(Self, err);
         if err=UnPack_Stopped then Result:=UnPack_Stopped;
         if Err=ACEERR_END then Result:=ACEERR_END;
         if (err<>ACEERR_END) and (err<>UnPack_Stopped) then result:=Unpack_ReadErr; // general read error, -> error in header isn't funny anyway...
         CloseAcefile;
         UnloadAceDll;
         exit;
        end;
      S:=''; for Temp:=0 to SizeOf(AceHeaderData.FileName) do if AceHeaderData.FileName[Temp]=#00 then break else S:=S+AceHeaderData.FileName[Temp]; // get filename from RarHeader
      if Assigned(OnTesting) then OnTesting(Self, AceHeaderData);
      FActualPos:=0;


   if (FFilesToProcess.Count=0) or (FFilesToProcess.Find(S,Temp)) then // extract file or just all
      begin    
        // preliminary password support...begin
        if ((AceHeaderData.Flags and ACE_FILEFLAG_PASSWORD)=ACE_FILEFLAG_PASSWORD) and (Assigned(OnReqPassword)) then
            begin
              OnReqPassword(Self,AceHeaderData,Password);
             if Password<>'' then AceSetPassword(unAcehandle,@Password[1]);
             end;
        // preliminary password support...end
      err:=AceProcessFile(unAcehandle,ACECMD_TEST,nil);
      if Assigned(OnTest) then OnTest(Self, AceHeaderData, (err=0) );
      end
     else err:=AceProcessFile(unAcehandle,ACECMD_SKIP,nil);

    if err<>0 then begin
      If Assigned(OnError) then OnError(Self,err);
      Testdone:=true;
    end;
  until Testdone;
  CloseAcefile; // make sure we return the memory we gobbled up; if it's already gone, this won't do a thing...
  UnloadAceDll; // make sure we get rid of the Dll ; if it's already gone, it doesn't do anything
  result:=err;
end;


Function TdAce.ListArchive:integer;
var ACEOpenArchiveData:tACEOpenArchiveData;
    ACEHeaderData:tACEHeaderData;
    err:integer;
    temp:integer;
    Listdone:boolean;
    s,password:string;
Begin
  xSelf:=Self;
  err:=255; // shut up compiler... ;-)
  if (not LoadAceDll(Path2UnAceDll)) then
                                      begin
                                        if Assigned(onError) then OnError(Self,UnPack_UnAceDllNotLoaded);
                                        result:=UnPack_UnAceDllNotLoaded;
                                        exit;
                                       end;
  if unAcehandle=0 then begin  {open first!}
    fillchar(AceOpenArchiveData, sizeof(tAceOpenArchiveData),#0); {Clear it, just to make sure !}
    with AceOpenArchiveData do begin
      ArcName:=pchar(FArchive_file);        {Set the Archive File}
      OpenMode:=ACEOPEN_LIST;     {Set the open-mode}
      ProcessDataProc:=@ProgressProc;
      ChangeVolProc:=@ChangeProc;
    end;
    unAcehandle:=AceOpenArchive(AceOpenArchiveData); {Now open the Archive and gobble up some memory}
    err:=ACEOpenArchiveData.OpenResult;
    if err<>0 then begin {if not opened ok, bail !}
                                if Assigned(OnError) then OnError(Self,err);
                                CloseAcefile;
                                UnloadAceDll;
                                result:=err;
                                exit;
                               end;
  end else
    result:=err;
  fillchar(AceHeaderData,sizeof(TAceHeaderData),#0);
  listdone:=false;
  repeat
     err:=AceReadHeader(unAcehandle,AceHeaderData);
     if FStop then
      begin
        FStop:=False;
        result:=UnPack_Stopped;
        CloseAceFile;
        UnloadAceDll;
        Exit;
      end;
    if err<>0 then
       begin
         if Assigned(OnError) then OnError(Self, err);
         if err=UnPack_Stopped then Result:=UnPack_Stopped;
         if Err=ACEERR_END then Result:=ACEERR_END;
         if (err<>ACEERR_END) and (err<>UnPack_Stopped) then result:=Unpack_ReadErr; // general read error, -> error in header isn't funny anyway...
         CloseAcefile;
         UnloadAceDll;
         exit;
        end;
      S:=''; for Temp:=0 to SizeOf(AceHeaderData.FileName) do if AceHeaderData.FileName[Temp]=#00 then break else S:=S+AceHeaderData.FileName[Temp]; // get filename from RarHeader
      if Assigned(OnListing) then OnListing(Self, AceHeaderData);
      FActualPos:=0;

    // preliminary password support...begin
     if ((AceHeaderData.Flags and ACE_FILEFLAG_PASSWORD)=ACE_FILEFLAG_PASSWORD) and (Assigned(OnReqPassword)) then
      begin
        OnReqPassword(Self,AceHeaderData,Password);
        if Password<>'' then AceSetPassword(unAcehandle,@Password[1]);
      end;
      // preliminary password support...end


      err:=AceProcessFile(unAcehandle,ACECMD_SKIP,nil);
      if Assigned(OnList) then OnList(Self, AceHeaderData, err=0);
    if err<>0 then begin
      If Assigned(OnError) then OnError(Self,err);
      listdone:=true;
    end;
  until Listdone;
  CloseAcefile; // make sure we return the memory we gobbled up; if it's already gone, this won't do a thing...
  UnloadAceDll; // make sure we get rid of the Dll ; if it's already gone, it doesn't do anything
  result:=err;
end;

Function TdAce.ValidateArchive:integer;
var ACEOpenArchiveData:tACEOpenArchiveData;
begin
  xSelf:=Self;
  if (not LoadAceDll(Path2UnAceDll)) then
                                      begin
                                        if Assigned(onError) then OnError(Self,UnPack_UnAceDllNotLoaded);
                                        result:=UnPack_UnAceDllNotLoaded;
                                        exit;
                                       end;
  if unAcehandle=0 then begin  {open first!}
    fillchar(AceOpenArchiveData, sizeof(tAceOpenArchiveData),#0); {Clear it, just to make sure !}
    with AceOpenArchiveData do begin
      ArcName:=pchar(FArchive_file);        {Set the Archive File}
      OpenMode:=ACEOPEN_LIST;     {Set the open-mode}
    end;
  UnAcehandle:=AceOpenArchive(AceOpenArchiveData); {Now open the Archive and gobble up some memory}
  end;
  Result:=ACEOpenArchiveData.OpenResult;
  CloseAcefile; // make sure we return the memory we gobbled up; if it's already gone, this won't do a thing...
  UnloadAceDll; // make sure we get rid of the Dll ; if it's already gone, it doesn't do anything
end;


end.
